<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\Manager;
use \Exception as Exception;


class Evento extends CrudWithParameterBag {
        const dataSourceEventos = 'select_eventos';
        const dataSourceUnidades = 'unidades_participantes_eventos';
      
        protected $parameterBagColumns = ['NRORG'];
        
 
        public function __construct (ParameterBag $parameterBag, Manager $dataSourceManager) {
                $this->parameterBag = $parameterBag;
                $this->dataSourceManager = $dataSourceManager;
        }
        
        public function findEvento(DTO\Request\Filter $request, DTO\Response $response){
                $this->dataSourceName = self::dataSourceEventos;
                parent::find($request, $response);
        }
        
        public function saveEvento(DTO\Request\DataSet $request, DTO\Response $response) {
            $this->dataSourceName    = self::dataSourceEventos;
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            
            try {
                $dataSet = $request->getDataSet();
                $dataSet->setDataSourceName($this->dataSourceName);
                $persistedRows = $this->dataSourceManager->persist($dataSet);
                $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
                $nrPersistedRows = count($persistedRows);
                
            } catch (Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
          
        public function findUnidadeEvento(DTO\Request\Filter $request, DTO\Response $response){
               
                $this->dataSourceName = self::dataSourceUnidades;
                $this->parameterBagColumns = array('NRORG', 'CDEVENTO');
                parent::find($request, $response);
        }
        
        public function saveUnidadeEvento(DTO\Request\DataSet $request, DTO\Response $response){
                $this->dataSourceName    = self::dataSourceUnidades;
                $dataSet = $request->getDataSet();
                $rows = $dataSet->getRows();
                
                try {
                    $dataSet = $request->getDataSet();
                    $dataSet->setDataSourceName($this->dataSourceName);
                    $persistedRows = $this->dataSourceManager->persist($dataSet);
                    $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
                    $nrPersistedRows = count($persistedRows);
                    
                } catch (Exception $e) {
                    $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
                }
            }
        
        public function deleteUnidadeEvento (DTO\Request\Row $request,DTO\Response $response) {
        	try {
        	    $this->dataSourceName = 'unidades_participantes_eventos';
                    parent::delete($request,$response);
                } catch (\Exception $e) {
                    $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
                }
        }

}